class Customer
  def initialize(name)
    @name    = name
    @rentals = Array.new
  end

  def addRental(arg)
    @rentals.push( arg )
  end

  def getName
    @name
  end

  def statement
    totalAmount = 0
    frequentRenterPoints = 0
    # Enumeration entries = rentals.elements();
    result = "Rental Record for " + getName + "\n"

    @rentals.each do |entry|
      thisAmount = 0

      # determine amounts for each line
      case entry.getMovie.getPriceCode
        when Movie::REGULAR
               thisAmount = thisAmount + 2
               if entry.getDaysRented > 2
                  thisAmount = thisAmount + (entry.getDaysRented - 2) * 1.5
               end
        when Movie::NEW_RELEASE
               thisAmount = thisAmount + entry.getDaysRented * 3
        when Movie::CHILDRENS
               thisAmount = thisAmount + 1.5
               if entry.getDaysRented > 3
                  thisAmount = thisAmount + (entry.getDaysRented - 3) * 1.5
               end
      end

      # add frequent renter points
      frequentRenterPoints = frequentRenterPoints + 1
      # add bonus for a two day new release rental
      if (entry.getMovie.getPriceCode == Movie::NEW_RELEASE) && entry.getDaysRented > 1
         frequentRenterPoints = frequentRenterPoints + 1
      end

      # show figures for this rental
      result = result + "\t" + entry.getMovie.getTitle +
               "\t" + thisAmount.to_s + "\n"
      totalAmount = totalAmount + thisAmount
    end

    # add footer lines
    result = result + "Amount owed is " + totalAmount.to_s + "\n"
    result = result +
             "You earned " + frequentRenterPoints.to_s +
             " frequent renter points"
    result
  end
end
